## Architecture

### Future goals

* Portable VM that runs locally for the user, so they can keep their data local, and private, if they desire
* Composable infrastructure, that allows users to develop services for community members, but also promote them to proper place in the infrastructure
* Ability to run all pieces of infrastructure across any cloud provider, or even on a member's own hardware, but acting like a true part of the overall system
* Completely software defined infrastructure, or "Infrastructure as code"

### Pieces in place right now, to promote the stated goals

* LDAP authentication for all services, servers and containers
* NFS filesystem, available to be mounted anywhere, containing all user's home directory
* Ingress VPN, with private network space, for all pieces of the infrastructure, to include the portable VM homes
* Ansible used to configure machines, to ensure a baseline configuration to allow it to interact properly with the infrastructure
